package Food.app.ui;

import java.util.ArrayList;

import android.app.Activity;
import android.content.ContentValues;
import android.content.Intent;
import android.graphics.PixelFormat;
import android.hardware.Camera;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore.Images.Media;
import android.util.Log;
import android.view.KeyEvent;
import android.view.MenuItem;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
/**
 * View to use and display the camera and taken pictures
 * @author kelly
 *
 */
public class CameraView extends Activity implements SurfaceHolder.Callback, Constant {
    
	private Camera camera;
	private boolean isPreviewRunning = false;
	private SurfaceView surfaceView;
	private SurfaceHolder surfaceHolder;
	FileCommunicator fc = new FileCommunicator();
	FoodRequester FR = new FoodRequester();	
	FoodHelper FH = new FoodHelper();
	
	// ResPicName: 
	static String filename;
	Restaurant MyRes;

	String ResInforString;
	ArrayList<String> PicPathlst;								// Search Food Path List

	
	// FoodName:
	String FoodName;

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle icicle) {
        super.onCreate(icicle);
        
		Intent intent = this.getIntent();
		
		this.MyRes = (Restaurant)intent.getSerializableExtra("MyRes");
		this.FoodName = intent.getStringExtra("FoodName");
		this.PicPathlst = intent.getStringArrayListExtra("PicPathlst");
		
		ResInforString = MyRes.getResPicName();
		
        Log.i(tag, "onCreate");
        getWindow().setFormat(PixelFormat.TRANSPARENT);      
        setContentView(R.layout.foodpicframe);
        this.surfaceView = (SurfaceView)findViewById(R.id.surface);
        this.surfaceHolder = this.surfaceView.getHolder();
        this.surfaceHolder.addCallback(this);
        this.surfaceHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);              
        
    }
    
    public boolean onCreateOptionsMenu(android.view.Menu menu){
    	
    	MenuItem item = menu.add(0,0,0,"Upload Photos?");
    	item.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
			
			
			public boolean onMenuItemClick(MenuItem item) {
				
				 FileCommunicator fc = new FileCommunicator();
				 String MY_FileName = PIC_PATH + filename;   
				
			     fc.uploadFile(MY_FileName,UPLOAD_FILE,"myfile");
			     
			     FH.UploadFoodPic(filename, FoodName, MyRes);  
			     			     
			     PicPathlst.add(filename);
			     Intent intent = new Intent(CameraView.this, FoodView.class); 
				StoreVariables(intent);

				startActivity(intent);
				return true;
			}
		});
    	return true;
    }
    

    Camera.PictureCallback mPictureCallbackRaw = new Camera.PictureCallback(){
    	public void onPictureTaken(byte [] data, Camera c){
       		camera.startPreview();

    	}
    };
    Camera.ShutterCallback mShutterCallback = new Camera.ShutterCallback() {
					
		public void onShutter() {
			
		}
	};
	/**
	 * Take picture
	 */
	public boolean onKeyDown(int keyCode, KeyEvent event){
		ImageCaptureCallback camDemo = null;
		if(keyCode == KeyEvent.KEYCODE_DPAD_CENTER){
			try{	        	
				
				filename = (FR.getCurrentTime() + FoodName + ResInforString).replaceAll("\\s", "").replaceAll(":", "").replaceAll("-", "");
				ContentValues values = new ContentValues();
				
				Uri uri = this.getContentResolver().insert(Media.EXTERNAL_CONTENT_URI, values);
				camDemo = new ImageCaptureCallback(this.getContentResolver().openOutputStream(uri), filename);
						
			}catch(Exception ex){}
		}
		if(keyCode == KeyEvent.KEYCODE_BACK){
			return super.onKeyDown(keyCode, event);
		}
		if(keyCode == KeyEvent.KEYCODE_DPAD_CENTER){
			this.camera.takePicture(this.mShutterCallback, this.mPictureCallbackRaw, camDemo);
			return true;
		}
		return false;
	}
	
	protected void onResume(){
		Log.i(tag, "onResume");
		super.onResume();
	}
	
	protected void onSaveInstanceState(Bundle outState){
		super.onSaveInstanceState(outState);
	}
	
	protected void onStop(){
		super.onStop();
	}
    /**
     * configuration of the parameters		
     */
	public void surfaceChanged(SurfaceHolder holder, int format, int w, int h) {

		if(this.isPreviewRunning){
			this.camera.stopPreview();
		}
		Camera.Parameters p = this.camera.getParameters();
		p.setPreviewSize(213, 350);
		p.setPictureSize(213, 350);
		
		p.set("orientation", "portrait");
		p.set("rotation", 90);
		
		this.camera.setParameters(p);
		try{
			this.camera.setPreviewDisplay(holder);
		}catch(Exception ex){}
		this.camera.startPreview();
		this.isPreviewRunning = true;
		
	}

	/**
	 * Open the camera when it the surface created
	 */
	public void surfaceCreated(SurfaceHolder arg0) {

		this.camera = Camera.open();
		
	}
	/**
	 * Call when the surface destroyed
	 */
	
	public void surfaceDestroyed(SurfaceHolder arg0) {

		this.camera.stopPreview();
		this.isPreviewRunning = false;
		this.camera.release();
		
	}
	/**
	 * Store Variables
	 * @param intent
	 */
	private void StoreVariables(Intent intent){
		
		intent.putExtra("MyRes", this.MyRes).putExtra("FoodName", this.FoodName).putExtra("PicPathlst", this.PicPathlst);
		
	}
	
    private static final String tag = CameraView.class.getName();
}
