package Food.app.ui;

import java.util.ArrayList;
import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.widget.ArrayAdapter;

/**
 * 
 * A view to display a list of comment for a food
 * @author kelly
 *
 */
public class CommentListView extends ListActivity {
 
	ArrayList<Food> foodlist = new ArrayList<Food>();

	FoodHelper FH = new FoodHelper();
	String FoodName;
	Restaurant MyRes;
	
	@Override
	public void onCreate(Bundle icicle) {
		
		super.onCreate(icicle);
		setContentView(R.layout.foodlistview);
		
		// Get variables from the previous activity
		Intent intent = this.getIntent();
		this.MyRes = (Restaurant)intent.getSerializableExtra("MyRes");
		this.FoodName = intent.getStringExtra("FoodName");
		
		// Extend the Restaurant's information
		String ResName = MyRes.getResName();
		double ResLat = MyRes.getResLoc().getLat();
		double ResLong = MyRes.getResLoc().getLong();
				
		// Get the list of comments for the food
		ArrayList<Comment> clst = FH.getFoodComment(FoodName, ResName, ResLat, ResLong);
			
    	if(clst!=null){
    		
    		String[] CommentArray = new String[clst.size()];
    		
    		int i = 0;
    		
    		for(Comment myComm: clst){
    			
    			CommentArray[i] = myComm.getFoodComm() + "\n" + myComm.getCommTime();
    			Log.i(tag,"CommentArray[i] = " + CommentArray[i]);
    			i++;
    		}
    	
    		setListAdapter(new ArrayAdapter<String>(this,android.R.layout.simple_list_item_1, CommentArray));
    	}
	}
	/**
	 * 
	 * For user to write comment for a food item
	 * 
	 */
    public boolean onCreateOptionsMenu(android.view.Menu menu){
    	
    	MenuItem item = menu.add(0,0,0,"Write Comment");
    	
    	item.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
			
			public boolean onMenuItemClick(MenuItem item) {

				Intent intent = new Intent(CommentListView.this, CommentView.class);  
				
				StoreVariables(intent);
	    		   
				startActivity(intent);

				return true;
			}
		});
    	return true;
    }
    
	/**
	 * Store all necessary variables for the next activity to use
	 * @param intent
	 */
	private void StoreVariables(Intent intent){
		
		intent.putExtra("MyRes", this.MyRes).putExtra("FoodName", this.FoodName);
		
	}
	
	
	public static String tag = CommentListView.class.getName();
}