package Food.app.ui;

import java.util.ArrayList;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.EditText;

/**
 * A view to write comment for a food item
 * @author kelly
 *
 */
public class CommentView extends Activity implements OnClickListener {
 
	ArrayList<Food> foodlist = new ArrayList<Food>();
	
	FoodHelper FH = new FoodHelper();
	
	View submitcommentbutton;
	
	EditText commentfield;
	
	Restaurant MyRes;
	
	String FoodName;
	
	@Override
	public void onCreate(Bundle icicle) {
		
		super.onCreate(icicle);
		
		Intent intent = this.getIntent();
		
		this.MyRes = (Restaurant)intent.getSerializableExtra("MyRes");
		
		this.FoodName = intent.getStringExtra("FoodName");

		setContentView(R.layout.commentview);
				
		submitcommentbutton = this.findViewById(R.id.submitcommentbutton);
		
		submitcommentbutton.setOnClickListener(this);       
		
		commentfield = (EditText)this.findViewById(R.id.commentfield);
	
	}
	/**
	 * 
	 * Write review for the food item
	 */
	public void onClick(View v)
    {

		String FoodComm = commentfield.getText().toString().trim();	
        
		String ResName = MyRes.getResName();
		
		double ResLat = MyRes.getResLoc().getLat();
		
		double ResLong = MyRes.getResLoc().getLong();
		
        FH.CommentFood(FoodName, ResName, ResLat, ResLong, FoodComm);
               
		Intent intent = new Intent(this, CommentListView.class); 
		
		this.StoreVariables(intent);
		
		startActivity(intent);
    }
	
	/**
	 * Store all necessary variables for the next activity to use
	 * @param intent
	 */
	private void StoreVariables(Intent intent){
		
		intent.putExtra("MyRes", this.MyRes).putExtra("FoodName", this.FoodName);
		
	}	
	
	public static String tag = CommentView.class.getName();
}