package Food.app.ui;

import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import android.util.Log;

public class FileCommunicator implements Constant{
	
	private String PhoneFile;	
	private String ServerLink;	
	private String tempFileName;
	
	/**
	 * Upload file to the server
	 * @param myPhoneFile
	 * @param myServerLink
	 * @param myTempFile
	 * @return
	 */
	
    public boolean uploadFile(String myPhoneFile, String myServerLink, String myTempFile) {
 
    	this.PhoneFile = myPhoneFile;
		this.ServerLink = myServerLink;	
		this.tempFileName = myTempFile;
        try {
        	File uploadFile = new File(this.PhoneFile);
        	fileInputStream = new FileInputStream(uploadFile);	
        	ConfigConn();	
			// open data output stream
			dos = new DataOutputStream(conn.getOutputStream());
			dos.writeBytes(twoHyphens + boundary + lineEnd);
			dos.writeBytes("Content-Disposition: form-data; test=" + QuoStr("just Testing") + ";name=" + QuoStr(this.tempFileName) + ";filename="+QuoStr(this.PhoneFile) + lineEnd);
			dos.writeBytes(lineEnd);
			// create a buffer of maximum size
			int bytesAvailable = fileInputStream.available();
			
			int bufferSize = Math.min(bytesAvailable, MAXBufferSize);
			byte[] buffer = new byte[bufferSize];
			// read file and write it into form...
			int bytesRead = fileInputStream.read(buffer, 0, bufferSize);
			while (bytesRead > 0)
            {
            	dos.write(buffer, 0, bufferSize);
                bytesAvailable = fileInputStream.available();
                bufferSize = Math.min(bytesAvailable, MAXBufferSize);
                bytesRead = fileInputStream.read(buffer, 0, bufferSize);
            }
            // send multipart form data necesssary after file data...
            dos.writeBytes(lineEnd);
            dos.writeBytes(twoHyphens + boundary + twoHyphens + lineEnd);
            // close streams
            fileInputStream.close();
            dos.flush();
            InputStream is = conn.getInputStream();
            int ch;
            StringBuffer b =new StringBuffer();
            while( ( ch = is.read() ) != -1 ) {
                b.append( (char)ch );
            }
            String s=b.toString();
            Log.i(tag, s);
            dos.close();

		}catch (Exception e) {
			
			e.printStackTrace();
			return false;
		}
		return true;     
    }
   
    
    private String QuoStr(String ori){
    	
    	return DOUBLE_QUO_STR + ori + DOUBLE_QUO_STR;
    	
    }
    
    /**
     * 
     * Connect to the server
     * 
     */
    private void ConfigConn() throws IOException{
    	
    	URL connectURL = new URL(this.ServerLink);   	
    	conn = (HttpURLConnection)connectURL.openConnection();	
		conn.setDoInput(true);											// allow inputs
		conn.setDoOutput(true);											// allow outputs
		conn.setUseCaches(false);										// don't use a cached copy
		conn.setRequestMethod(POST_STR); 								// use a post method
		conn.setRequestProperty(CONNECTION_STR,ALIVE_STR); 				// set post headers
		conn.setRequestProperty(CONTENT_TYPE_STR,MUL_DATA_STR+boundary);	    	
 
    }
    
    private HttpURLConnection conn = null;
    public final String tag = FileCommunicator.class.getName();
	private DataOutputStream dos = null;
	private FileInputStream fileInputStream = null;
	 
}