package Food.app.ui;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import android.util.Log;

/**
 * Class to communicate with the server
 * @author Kelly
 *
 */
public class FoodRequester {
	
	public static final String IP = "rome.dynamiccreation.com/~admin22";  //please change the ip address into your server address instead
	public static final String serverLink = "http://" + IP + "/foodserver.php?function=";
	
	public String searchFood(double LatMax, double LatMin, double LongMax, double LongMin,String FoodNametemp, int str, int end){
		
		String FoodName = FoodNametemp.replaceAll(" ", "%20");	
		String url = serverLink + "searchFood&LatMax=" + LatMax + 
		"&LatMin=" + LatMin + "&LongMax=" + LongMax +
		"&LongMin="+ LongMin + "&FoodName=" + FoodName + "&str=" + str + "&end=" + end;
		
		return getDBresult(url);
	}
	/**
	 * Make a URL request to the PHP server to get a list of restaurant
	 * @param LatMax
	 * @param LatMin
	 * @param LongMax
	 * @param LongMin
	 * @param str
	 * @param end
	 * @return
	 */

	public String getResList(double LatMax, double LatMin, double LongMax, double LongMin, int str, int end){
		
		String url = serverLink + "getResList&LatMax=" + LatMax + 
		"&LatMin=" + LatMin + "&LongMax=" + LongMax +
		"&LongMin="+ LongMin + "&str=" + str + "&end=" + end;

		return getDBresult(url);
	}
	/**
	 * URL to ask server for the current time
	 * @return
	 */
	public String getCurrentTime(){
		
		String url = serverLink + "getCurrentTime";
		
		return getDBresult(url);
		
	}
	
	/**
	 * URL to Request server to get a Restaurant's menu
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 * @param str
	 * @param end
	 * @return
	 */
	public String getResMenu(String ResNameTemp, double ResLat, double ResLong, int str, int end){
		
		String ResName = ResNameTemp.replaceAll(" ", "%20");		
		String url = serverLink + "getResMenu&ResName=" + ResName + 
		"&ResLat=" + ResLat + "&ResLong=" + ResLong + 
		"&str=" + str + "&end=" + end;

		return getDBresult(url);
	}
	/**
	 * URL to Request server to get food information
	 * @param FoodNameTemp
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 * @return
	 */
	public String getFood(String FoodNameTemp, String ResNameTemp, double ResLat, double ResLong){

		String ResName = ResNameTemp.replaceAll(" ", "%20");
		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String url = serverLink + "getFood&ResName=" + ResName + "&FoodName=" + FoodName +
		"&ResLat=" + ResLat + "&ResLong=" + ResLong;

		return getDBresult(url);
	}
	/**
	 * URL to Request server to get a food information
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 * @return
	 */
	public String getRes(String ResNameTemp, double ResLat, double ResLong){

		String ResName = ResNameTemp.replaceAll(" ", "%20");		
		String url = serverLink + "getRes&ResName="  + ResName +
		"&ResLat=" + ResLat + "&ResLong=" + ResLong;

		return getDBresult(url);
	}	
	/**
	 * URL to Search a list of foods within a given zip code
	 * @param FoodNameTemp
	 * @param ResZip
	 * @param str
	 * @param end
	 * @return
	 */
	public String searchFoodbyZipCode(String FoodNameTemp, int ResZip, int str, int end){
		
		String FoodName = FoodNameTemp.replaceAll(" ", "%20");
		String url = serverLink + "searchFoodbyZipCode&FoodName="  + FoodName + "&ResZip=" + ResZip + "&str=" + str + "&end=" + end;

		return getDBresult(url);		
		
	}
	/**
	 * URL to Rate a food item
	 * @param FoodNameTemp
	 * @param NewFoodRate
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 */
	public void RateFood(String FoodNameTemp, double NewFoodRate, String ResNameTemp, double ResLat, double ResLong){

		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String ResName = ResNameTemp.replaceAll(" ", "%20");			
		String url = serverLink + "RateFood&ResName="  + ResName + "&FoodName=" + FoodName + "&NewFoodRate=" + NewFoodRate +
		"&ResLat=" + ResLat + "&ResLong=" + ResLong;

		getDBresult(url);
	}
	/**
	 * URL to comment a food item
	 * @param FoodNameTemp
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 * @param FoodCommTemp
	 */
	public void CommentFood(String FoodNameTemp, String ResNameTemp, double ResLat, double ResLong, String FoodCommTemp){

		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String ResName = ResNameTemp.replaceAll(" ", "%20");
		String FoodComm = FoodCommTemp.replaceAll(" ", "%20");
		String url = serverLink + "CommentFood&ResName="  + ResName + "&FoodName=" + FoodName  + "&FoodComm="
		+ FoodComm + "&ResLat=" + ResLat + "&ResLong=" + ResLong;

		getDBresult(url);
	}	

	/**
	 * URL to upload a food's picture
	 * @param PicPath
	 * @param FoodNameTemp
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 */
	public void UploadFoodPic(String PicPath, String FoodNameTemp, String ResNameTemp, double ResLat, double ResLong){

		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String ResName = ResNameTemp.replaceAll(" ", "%20");
		//String PicPath = (FoodNameTemp + ResNameTemp + ResLat + ResLong).replaceAll("\\s", "").replaceAll(":", "").replaceAll("-", ""); 
		String url = serverLink + "UploadFoodPic&PicPath=" + PicPath + "&ResName="  + ResName + "&FoodName=" + FoodName + "&ResLat=" + ResLat + "&ResLong=" + ResLong;

		getDBresult(url);
	}
	


/**
 * Communicate with Server: connect to the server and get result back
 * @param function
 * @return response from server
 */
	
    private String getDBresult(String function){
        
    	String result = "";
    	URL url = null;	
    	
        try {
        	url = new URL(function);
        	   
        } catch (MalformedURLException e) {
        	
        	Log.i("Malformed URL Exception", e.getMessage());
        }
       
        try {
        	   HttpURLConnection urlConn = (HttpURLConnection) url.openConnection();       	
               BufferedReader in = new BufferedReader(new InputStreamReader(urlConn.getInputStream()));
        	   String inputLine;
        	   while((inputLine = in.readLine()) != null)
        	   {
        		   result += inputLine;

        	    }
        }
        catch (IOException e) {
        	
        	Log.i("IO Exception", e.getMessage());
        }
        
        return result;
        	
    }
    /**
     * URL to download a food picture
     * @param FoodNameTemp
     * @param ResNameTemp
     * @param ResLat
     * @param ResLong
     * @param str
     * @param end
     * @return
     */
	public String DownloadFoodPic(String FoodNameTemp, String ResNameTemp, double ResLat, double ResLong, int str, int end){

		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String ResName = ResNameTemp.replaceAll(" ", "%20");
		String url = serverLink + "DownloadFoodPic&ResName="  + ResName + "&FoodName=" + FoodName + "&ResLat=" + ResLat + "&ResLong=" + ResLong + "&str=" + str + "&end=" + end;

		return getDBresult(url);
	}
	/**
	 * URL to download a food picture
	 * @param FoodNameTemp
	 * @param ResNameTemp
	 * @param ResLat
	 * @param ResLong
	 * @return
	 */
	
	public String DownloadFoodPic(String FoodNameTemp, String ResNameTemp, double ResLat, double ResLong){

		String FoodName = FoodNameTemp.replaceAll(" ", "%20");	
		String ResName = ResNameTemp.replaceAll(" ", "%20");
		String url = serverLink + "DownloadFoodPic&ResName="  + ResName + "&FoodName=" + FoodName + "&ResLat=" + ResLat + "&ResLong=" + ResLong;

		return getDBresult(url);
	}
	
}
