package Food.app.ui;

import java.text.DecimalFormat;
import java.util.ArrayList;

import android.app.Activity;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.RatingBar;
import android.widget.TextView;

/**
 * Activity to display a food item
 * @author kelly
 *
 */
public class FoodView extends Activity implements OnClickListener, Constant {
 
	TextView foodinfo;
	FoodHelper FH = new FoodHelper();	
	FileCommunicator fc = new FileCommunicator();
	
	private RatingBar myRatingBar; 
	
	String ResName;
	double ResLat;
	double ResLong;
	
	ImageView icon;
	static String picNamestr;
	String picName;
	int index = 0;
	int endindex = 2;
	View nextbutton;
	View prevbutton;
	
	Restaurant MyRes;
	String FoodName;
	ArrayList<String> PicPathlst;
	
	private int currentIndex;
	ArrayList<Drawable> foodPics = new ArrayList<Drawable>();	//the entire arraylist must be instantiated after
																//	retrieving file names
	int NumOfPic = 0;
	Object myLock = new Object();
	Food myfood;

	
	@Override
	public void onCreate(Bundle icicle) {

		super.onCreate(icicle);		
   	    setContentView(R.layout.foodview);
   	    
		Intent intent = this.getIntent();
		
		this.MyRes = (Restaurant)intent.getSerializableExtra("MyRes");
		this.FoodName = intent.getStringExtra("FoodName");
		this.PicPathlst = intent.getStringArrayListExtra("PicPathlst");		
 
   	    if(this.PicPathlst != null){
   		   this.NumOfPic = this.PicPathlst.size();
   	   	   InitializeFoodPics();
   	    } 	    	
   	    	
		myfood = FH.getFood(FoodName, MyRes);
		
		if(myfood != null){
			
   	    	ResName = MyRes.getResName();
   	    	ResLat = MyRes.getResLoc().getLat();
   	    	ResLong = MyRes.getResLoc().getLong();

			foodinfo=(TextView)findViewById(R.id.foodinfo);
			


			String FoodRate = df.format(myfood.getFoodRate());
			
			String foodString = myfood.getFoodName() + "\n$"
			+ myfood.getFoodPrice() +  "\n"
			+  FoodRate + "/5";
			
			Log.i(tag, "Food infor = " + foodString);
			
			foodinfo.setText(foodString);
			
			ArrayList<Comment> clst = FH.getFoodComment(FoodName, ResName, ResLat, ResLong);

			View getCommentbutton = this.findViewById(R.id.getcomment);
			getCommentbutton.setOnClickListener(this); 
			
			if(clst == null){
				
				getCommentbutton.setEnabled(false);
				
			}
			
			View putCommentbutton = this.findViewById(R.id.putcomment);
			putCommentbutton.setOnClickListener(this); 	

			nextbutton = this.findViewById(R.id.next);
			nextbutton.setOnClickListener(this); 
			
			prevbutton = this.findViewById(R.id.prev);
			prevbutton.setOnClickListener(this); 			
			prevbutton.setEnabled(false);
			

			// Restaurant picture's name 
			picName = FoodName.replaceAll("\\s", "")
			+ MyRes.getResPicName();
						
			picNamestr = PicPathlst.get(0);
			icon = (ImageView)this.findViewById(R.id.foodpic);
			 
			 
			 // Rating Bar Logic
			myRatingBar = (RatingBar) findViewById(R.id.RatingBar01); 
				
			RatingBar.OnRatingBarChangeListener l=new RatingBar.OnRatingBarChangeListener() {  
					
				public void onRatingChanged(RatingBar ratingBar, float rating, boolean fromTouch)  {  
 						
					Log.i(tag, "Rating = " + rating);
					FH.RateFood(FoodName, rating, ResName, ResLong, ResLat);
					myfood = FH.getFood(FoodName, MyRes);
					String FoodRate = df.format(myfood.getFoodRate());
						
					String foodString = myfood.getFoodName() + "\n$"
					+ myfood.getFoodPrice() +  "\n"
					+  FoodRate + "/5";
						
					Log.i(tag, "Food infor = " + foodString);
						
					foodinfo.setText(foodString);
						
				}  
			};  
				
			myRatingBar.setOnRatingBarChangeListener(l);  
										
			GetPic(FoodView.INITIAL);
			 	
		}

	}
	/**
	 * Handle when any buttons are clicked
	 */
	public void onClick(View v)
    {
		Intent intent;
		
		switch(v.getId())
    	{
    	   
    	   case R.id.getcomment:   
    		   
    		   intent = new Intent(this, CommentListView.class); 
    		   StoreVariables(intent);
    		   startActivity(intent);
    		   break;
    		   
    	   case R.id.putcomment:  

    		   intent = new Intent(this, CommentView.class);  
    		   StoreVariables(intent);
    		   startActivity(intent);
    		   break;
    		   
    	   case R.id.next:   
    		   GetPic(FoodView.NEXT);    		   
    		   break;
    		   
    	   case R.id.prev:
    		   GetPic(FoodView.PREVIOUS);
    		   break;    		   
    	}
    }
    
    /**
     * 
     * Set up Menu
     * 
     */
    public boolean onCreateOptionsMenu(android.view.Menu menu){
    	
    	MenuItem takePic = menu.add(0,0,0,"Take Photo");
    	MenuItem GetResView = menu.add(0,0,0,"Get Resturant");
    	takePic.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
			
			
			public boolean onMenuItemClick(MenuItem item) {
				
				Intent intent = new Intent(FoodView.this, CameraView.class);
				StoreVariables(intent);
				startActivity(intent);
				return true;
			}
		});
    	
    	GetResView.setOnMenuItemClickListener(new MenuItem.OnMenuItemClickListener() {
			
			
			public boolean onMenuItemClick(MenuItem item) {

				Intent intent = new Intent(FoodView.this, ResView.class); 
	    		
				StoreVariables(intent);
	    		   
				startActivity(intent);

				return true;
			}
		});
    	return true;
    }
	/**
	 * Initialized all food pictures into null in the beginning
	 */
    public void InitializeFoodPics(){
    	
    	if(PicPathlst!=null){
    		
        	for(int i = 0;  i < this.NumOfPic; i++)
        	{
        		foodPics.add(null);
        	}
    		
    	}  
    	else{
    		
    		Log.i(tag, "PicPathlst == null ");
    	}
    	
    	Log.i(tag, "foodPics size = " + foodPics.size());
    }
    
    /**
     * Assume all file names are retrieved in one shot
     **/
    protected void GetPic(int direction)
    {
    	synchronized(this.myLock)
    	{
					
    		if(direction == PREVIOUS)
    		{
    			if(currentIndex > 0)
    			{
    				currentIndex--;
    			}
    			Log.i(tag, "previous: currentIndex = " + currentIndex);
						
    		}
    		else if(direction == NEXT || direction == INITIAL)
    		{

    			// Move the currentIndex 
    			if(currentIndex < this.NumOfPic - 1)
    			{
    				currentIndex++;
				
    				if(direction == INITIAL)
    				{
    					currentIndex--;
    				}
				
    			}
    		}
    		
    		if(foodPics == null || foodPics.size() == 0){
    			
    			Log.i(tag, "foodPics == null!");
    			return;
    		}
    		
    		Log.i(tag, "PicPathlst size = " + PicPathlst.size());
    		Log.i(tag, "currentIndex = " + currentIndex);	
    		
    		//Get the right Image
    		if(foodPics.get(currentIndex) == null)				
    		{
    			Log.i(tag, "Image at currentIndex = " + currentIndex + " is null, attempting to retrieve pic from internet");
    			//Get the drawable and map to the ImageView for the 1st food picture				    
    			try 
    			{
    				//Thread.sleep(5000);
    				Drawable drawable = ImageCommunicator.GetDrawableFromConn(PicPathlst.get(currentIndex));
					
    				if(drawable != null)
    				{						
    					foodPics.set(currentIndex, drawable);
    				}
    				else
    				{
    					Log.i(tag, "drawable == null, currentIndex = " + currentIndex);
    					currentIndex--;
    				}
    			}
    			catch(Exception ex)
    			{
    				Log.i(tag, "Exception: " + ex.getMessage());
    			}
    		}
					
    		// Set to the foodpic			
    		icon.setImageDrawable(foodPics.get(currentIndex));
    		UpdateUIPermissions(direction);
    	}
		
		if(direction == FoodView.NEXT || direction == FoodView.INITIAL)
		{
			Thread prefetch = new Thread(new Runnable()
			{
				public void run() {
					
					PrefetchNextPic();
				}
			});
			prefetch.start();
		}
	
    }
    // control the buttons' permission
    private void UpdateUIPermissions(int direction){
    	
		
		if (direction == FoodView.NEXT && currentIndex == this.NumOfPic -1){
				
			nextbutton.setEnabled(false);
			prevbutton.setEnabled(true);
				
		}else if((direction == FoodView.PREVIOUS && currentIndex == 0) ||direction == FoodView.INITIAL){
				
			nextbutton.setEnabled(true);
			prevbutton.setEnabled(false);
				
		}else{
				
			prevbutton.setEnabled(true);
			nextbutton.setEnabled(true);
		}
    }

    private void PrefetchNextPic()
    {
    	synchronized(this.myLock)
    	{
    		
    		if(currentIndex < PicPathlst.size() - 1  && (this.foodPics.get(currentIndex + 1) == null))
    		{    		
    			Drawable drawable = ImageCommunicator.GetDrawableFromConn(PicPathlst.get(currentIndex + 1));
    		
    			if(drawable != null)
    			{				
    				foodPics.set(currentIndex + 1, drawable);    	
    				Log.i(tag, "Prefetch successful for currentIndex = " + currentIndex);
    			}
    			else
    			{
    				Log.i(tag, "Prefetch failed for currentIndex = " + currentIndex);
    			}
    		}
    	}
		
    }
    
    /**
     * Store all variables for later use
     * @param intent
     */
	public void StoreVariables(Intent intent){
		
		intent.putExtra("MyRes", this.MyRes).putExtra("FoodName", this.FoodName).putExtra("PicPathlst", this.PicPathlst);
		
	}
    
	//Constant Variables
    final static String tag = FoodView.class.getName();
	final static int NEXT = 1;
	final static int PREVIOUS = -1;
	final static int INITIAL = 0;
	final static DecimalFormat df = new DecimalFormat("0.00");
}