package Food.app.ui;

import android.app.Activity;
import android.graphics.drawable.Drawable;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Class for one row format for a list
 * @author kelly
 *
 */
public class IconAdapter extends ArrayAdapter<Object> {
	
	Activity context;
	String[] ResNameList;
	String[] picNameList;
	ImageView icon;
	
	public IconAdapter(Activity context, String[] ResNameList, String[] picNameList){
		
		super(context, R.layout.row, ResNameList);
		this.ResNameList = ResNameList;
		this.context = context;
		this.picNameList = picNameList;
	}
	/**
	 * Draw the view for one row
	 */
	
	public View getView(int position, View convertView, ViewGroup parent){
		
		
		View row = convertView;
		if(row==null){
			LayoutInflater inflater = context.getLayoutInflater();
			row = inflater.inflate(R.layout.row, null);
		}
			
		TextView label = (TextView)row.findViewById(R.id.label);		
		label.setText(ResNameList[position]);
		
		   /**
		    * 
		    * Get the drawable and map to the ImageView 
		    */
		try 
		{
			Drawable drawable = ImageCommunicator.GetDrawableFromConn(picNameList[position]);
			icon = (ImageView)row.findViewById(R.id.phone);
			if(drawable != null)
			{
				icon.setImageDrawable(drawable);
			}
			else
			{
				Log.i(tag, "drawable == null");
			}
		}
		catch(Exception ex)
		{
			Log.i(tag, "Exception: " + ex.getMessage());
		}
		
		return(row);
	}
	
	public static String tag = IconAdapter.class.getName();
	

}
