package Food.app.ui;

import java.io.FileOutputStream;
import java.io.OutputStream;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Bitmap.CompressFormat;
import android.hardware.Camera;
import android.hardware.Camera.PictureCallback;
import android.util.Log;
/**
 * Write the picture to SD card
 * @author kelly
 *
 */
public class ImageCaptureCallback implements PictureCallback{
	
	private OutputStream filoutputStream;	
	private String filename;
	
	public ImageCaptureCallback(OutputStream filoutputStream, String filename){
		
		this.filoutputStream = filoutputStream;
		this.filename = filename;
	}

	
	public void onPictureTaken(byte[] data, Camera camera) {
				
		try{
			
			Bitmap bm = BitmapFactory.decodeByteArray(data, 0, data.length);
			FileOutputStream buf = new FileOutputStream("/sdcard/dcim/Camera/" + filename);
			bm.compress(CompressFormat.JPEG, 50, buf);					
            buf.close();
            filoutputStream.flush();
            filoutputStream.close();

		}catch(Exception ex){
			
			Log.i(tag, "exception: " + ex.getMessage());
		}
		
	}
	
	public static String tag = ImageCaptureCallback.class.getName();

}
