package Food.app.ui;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.Drawable;
import android.util.Log;
/**
 * Set up the connection and get a drawable object from the server 
 * @author kelly
 *
 */
public class ImageCommunicator implements Constant{
		
    public static Drawable GetDrawableFromConn(String PicFileName){
    	
    	HttpURLConnection conn = null;
    	
		try{
			 
			String ServerLink = UPLOAD_PIC + PicFileName;
			URL connectURL = new URL(ServerLink);   	
		    conn = (HttpURLConnection)connectURL.openConnection();	
			conn.setDoInput(true);										// allow inputs
			conn.setDoOutput(true);										// allow outputs
			conn.setUseCaches(false);									// don't use a cached copy
			conn.setRequestMethod(POST_STR); 							// use a post method
			conn.setRequestProperty(CONNECTION_STR,ALIVE_STR); 			// set post headers
			conn.setRequestProperty(CONTENT_TYPE_STR,MUL_DATA_STR+boundary);
			
			if(conn.getInputStream() == null)
			{
				Log.i(tag, "input stream is null");
			}

			Drawable drawable = new BitmapDrawable(conn.getInputStream());
			
			if(drawable == null)
			{
				Log.i(tag, "GetDrawableFromConn returns null from try block");
				
				
				 Bitmap bm = null;
		            try {
		               
		                InputStream is = conn.getInputStream();
		                BufferedInputStream bis = new BufferedInputStream(is);
		                bm = BitmapFactory.decodeStream(bis);
		                bis.close();
		                is.close();
		                drawable = new BitmapDrawable(bm);
		           } catch (IOException e) {
		               Log.i(tag, "Error getting bitmap");
		           } 
		           
			}
			return drawable;
		}
		catch(Exception ex)
		{
			Log.i(tag, "GetDrawableFromConn of ImageCommunicator 'catch' block executed");
			return null;
		}
		finally
		{
			if(conn != null)
			{
				conn.disconnect();
				Log.i(tag, "conn disconnected");
			}
		}
    }
		
	public static String tag = ImageCommunicator.class.getName();
	 
}