package Food.app.ui;

import android.app.Activity;
import android.content.Intent;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.TextView;
 
/**
 * A view to display one restaurant
 * @author kelly
 *
 */
public class ResView extends Activity implements OnClickListener, Constant {
 
	TextView resinfo;
	FoodHelper FH = new FoodHelper();
		
	Restaurant MyRes;
	
	@Override
	public void onCreate(Bundle icicle) {
		
		super.onCreate(icicle);
   	    setContentView(R.layout.resview);
        View button;	
        
		Intent intent = this.getIntent();
		MyRes = (Restaurant)intent.getSerializableExtra("MyRes");
		MyRes = FH.getRes(this.MyRes);
	
		if(MyRes != null){
			
			// Set up Restaurant's Information (Name, Phone number, address)
			resinfo=(TextView)findViewById(R.id.resinfo);   	
			resinfo.setText(MyRes.getall());			
    	
			// Set up get menu button
			button = this.findViewById(R.id.getmenu);
			button.setOnClickListener(this); 
        	
			// Restaurant picture's name 
			String picName = MyRes.getResPicName();   
        			
			   /**
			    * Set up Restaurant picture
			    * Get the drawable and map to the ImageView for the Restaurant
			    */
			try 
			{
				Drawable drawable = ImageCommunicator.GetDrawableFromConn(picName);
				ImageView icon = (ImageView)this.findViewById(R.id.restpic);
				if(drawable != null)
				{
					icon.setImageDrawable(drawable);
				}
				else
				{
					Log.i(tag, "drawable == null");
				}
			}
			catch(Exception ex)
			{
				Log.i(tag, "Exception: " + ex.getMessage());
			}

		}
		else{
			
			Log.i(tag, "MyRes == null");
		}

	}
	
	public void onClick(View v)
    {
		Intent intent = new Intent(this, MenuView.class);  
		this.StoreVariables(intent);
		startActivity(intent);
    }
    
	private void StoreVariables(Intent intent){
		
		intent.putExtra("MyRes", MyRes);
		
	}
	
	public static String tag = ResView.class.getName();
}