package Food.app.ui;
import java.util.ArrayList;
import java.io.Serializable;

/**
 * Hold restaurant information
 * @author Kelly
 *
 */
public class Restaurant implements Serializable{
	
	private String ResName;	
	private Location ResLoc;		
	private transient ArrayList<Food> Menu;
	private String ResPhoneNum;
	
	public Restaurant(String myResName, Location myLoc){
		
		this.ResName = myResName;
		this.ResLoc = myLoc;
		
	}
	public Restaurant(String myResName, double myLat, double myLong){
		
		this.ResName = myResName;
		this.ResLoc = new Location(myLat, myLong);
		
	}
	/**
	 * Restaurant's constructor
	 * @param myResName
	 * @param myLoc
	 * @param myMenu
	 */
	public Restaurant(String myResName, Location myLoc, ArrayList<Food> myMenu, String myResPhoneNum){
		
		this.ResName = myResName;
		this.ResLoc = myLoc;
		this.Menu = myMenu;
		this.ResPhoneNum = myResPhoneNum;
	}

	/**
	 * Get value from the restaurant
	 * @return
	 */
	public String getall(){
		
		String result = "Name: " + this.getResName() + "\n" 
		+ "Phone: " + this.getResPhoneNum()  + "\n"
		+ "Address: " + this.getResLoc().getAddress() + "\n";
		
		return result;
		
	}	
	// setter
	public String setResName(String myResName){
		
		this.ResName = myResName;
		return this.ResName;
	}	
	public Location setResLoc(Location myLoc){
		
		this.ResLoc = myLoc;
		return this.ResLoc;
	}
	public String setResPhoneNum(String myResPhoneNum){
		
		this.ResPhoneNum = myResPhoneNum;
		return this.ResPhoneNum;
	}
	public ArrayList<Food> setMenu(ArrayList<Food> myMenu){
		
		this.Menu = myMenu;
		return this.Menu;
	}
	//getter
	public String getResName(){
		
		return this.ResName;
	}	
	public Location getResLoc(){
		
		return this.ResLoc;
	}
	public String getResPhoneNum(){
		
		return this.ResPhoneNum;
	}
	public ArrayList<Food> getMenu(){
		
		return this.Menu;
	}
	
	public String getResPicName(){
		
		String picName = ResName.replaceAll("\\s", "")
		+ Double.toString(ResLoc.getLat()).replaceAll("\\s", "").replaceAll("\\.", "")
		+ Double.toString(ResLoc.getLong()).replaceAll("\\s", "").replaceAll("\\.", "")
		+ ".jpg"; 
		
		return picName;
	}

}
